/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.Services;

import java.io.File;
import java.io.FileFilter;
import java.util.ArrayList;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

/**
 * Trieda poskytujuca web sluzbu, ktora vrati zoznam suborov obsahujucich udaje na vyhodnotenie 
 * odpovedi studenta.
 * @author R. Kuriak, S.Korecko
 */
@WebService(serviceName = "GetAnswerSpecFilesListWS")
public class GetAnswerSpecFilesListWS {
    
    /**
     * Metoda vrati zoznam suborov obsahujucich udaje na vyhodnotenie 
     * odpovedi studenta. Ide o vsetky textove subory (.txt), nachadzajuce sa v specifikovanom adresari.
     * Obsah suborov sa nijak nepreveruje.
     * @param absPath - absolutna cesta k adresaru v ktorom sa subory nachadzaju.
     * @return zoznam mien súborov
     */
    @WebMethod(operationName = "getAnswerSpecFilesList")
    public ArrayList<String> getAnswerSpecFilesList (@WebParam(name="absPath") String absPath){
        //nullpointerexception
        ArrayList<String> listSpTrStr = new ArrayList<String>();
        File directory = new File(absPath);
        FileFilter filter = new FileFilter() {

            @Override
            public boolean accept(File file) {
                
                return file.getName().endsWith("txt");
            }
        };
        File[] files = directory.listFiles(filter);
        listSpTrStr.add("dumb");    //by SKor: pridane na obidenie problemu ked sa v pripade 1-prvkoveho pola nic neprenesie namiesto 
        for(int index = 0; index < files.length; index++){
            String suboriky = files[index].toString();
            String nic = "";
            String plnacesta = absPath + "\\";
            String subor = suboriky.replace(plnacesta, nic);
            
            listSpTrStr.add(subor);
            
        }
        
       return listSpTrStr;
    
    }
   
}
