/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.abstraktne;

import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;


/**
 *trieda simulacia sluzi na samotnu simulaciu automatov ako aj na zabezpecenie
 * podpory pre graficky vystup
 * @author Stano
 */
public class Simulacia {

    /** instancia triedy main */
    //private static abstraktne.Main main = abstraktne.Main.getInst();
    private Premenne main;
    /** premenna zaznamu pasky */
    private List<String> paska;
    /** premenna zaznamu zasobnika */
    private List<String> zasobnik;
    /** premenna zaznamu viacerych pasok pre turingov stroj */
    private List<List> types;
    /** premenna udavajuca moznost vyberu dalsej instrukcie */
    public Boolean mozny;
    /** cislo vybranej instrukcie pre pokracovanie stroja */
    private int zhoda;
    /** predosla pozicia hlavy na paske pri konecnom automate */
    private int pozPredosla;
    /** premenna na zistenie prveho kroku pri konecnom automate */
    private Boolean oneStep;

    /**
     * konstruktor triedy simulacia
     */
    public void simulacia() {
    }

    /**
     * inicializacne nastavenia simulacie zasovnikoveho automatu
     */
    public Premenne simulaciaZasInit(Premenne get) {
        main = get;

        zhoda = 0;
        main.zaznam.zaznam.clear();

        main.program.setPrerus(false);
        mozny = true;
        main.program.setStavRJ(main.program.getZacStav());
        paska = main.paska.getPaska().get(0);
        zasobnik = main.paska.getPaska().get(1);
        vypisPaskaZas();

        return main;
    }

    /**
     * najdenie pokracujucej instrukcie zasobnikoveho automatu
     * @return cislo prvej najdenej vhodnej instrukcie
     */
    public Premenne simulaciaZasZhod(Premenne get) {
        main = get;
        mozny = false;
        zhoda = zhodaZas();
        main.program.setVyberI(zhoda);
        return main;
    }

    /**
     * spracovanie vybranej instrukcie zasobnikovym automatom
     */
    public Premenne simulaciaZasSprac(Premenne get) {
        main = get;
        zhoda = main.program.getVyberI();
        naplnpaskyZas(zhoda);
        main.program.setStavRJ(main.program.getProgram().get(zhoda).getStav2());
        main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(zhoda).getLine()
                + main.lang.getText(35) + main.program.getStavRJ()
                + main.lang.getText(36) + main.program.getProgram().get(zhoda).getTop());
        mozny = true;
        vypisPaskaZas();
        return main;
    }

    /**
     * vyhodnotenie zasobnikoveho automatu
     */
    public Premenne simulaciaZasVyhod(Premenne get) {
        main = get;
        if (zasobnik.size() == 1){
            if(zasobnik.get(0).contains("Z")) zasobnik.clear();
        }
        if ((paska.size() == 1) & (main.program.getMode() == 1) & (isKonc())) {
            main.cache.setErrLine(main.lang.getText(5));
            main.program.setSimOk(true);
        } else if ((paska.size() == 1) & (main.program.getMode() == 2) & (zasobnik.isEmpty())) {
            main.cache.setErrLine(main.lang.getText(12));
            main.program.setSimOk(true);
        } else if ((paska.size() == 1) & (main.program.getMode() == 3) & (zasobnik.isEmpty())
                & (isKonc())) {
            main.cache.setErrLine(main.lang.getText(15));
            main.program.setSimOk(true);
        } else {
            main.cache.setErrLine(main.lang.getText(28));
            main.program.setSimOk(false);
        }
        return main;
    }

    /**
     * naplnenie pasky a zasobnika pri posune v zasobnikovom automate
     * @param a cislo spracovavanej instrukcie
     */
    private void naplnpaskyZas(int a) {
        List<String> newPaska = new ArrayList<String>();
        List<String> newZas = new ArrayList<String>();
        if (!main.program.getProgram().get(a).getOneZnak1(0).contains("&")) {
            for (int i = 1; i < paska.size(); i++) {
                newPaska.add(paska.get(i));
            }
        } else {
            newPaska = paska;
        }
        if (!main.program.getProgram().get(a).getSmer().get(0).contains("&")) {
            for (int i = 0; i < main.program.getProgram().get(a).getSmer().size(); i++) {
                newZas.add(main.program.getProgram().get(a).getSmer().get(i));
            }
            for (int i = 1; i < zasobnik.size(); i++) {
                newZas.add(zasobnik.get(i));
            }
        } else {
            for (int i = 1; i < zasobnik.size(); i++) {
                newZas.add(zasobnik.get(i));
            }
        }
        //if (program.get(a).getOneZnak2(0).contains("Z") & (zasobnik.size() == 1)
        //        & !program.get(a).getSmer().get(program.get(a).getSmer().size() - 1).contains("Z")) {
        //    newZas.add("Z");
        //}
        paska = newPaska;
        zasobnik = newZas;
    }

    /**
     * zistenie pouzitelnej instrukcie zasobnikoveho automatu
     * @return
     */
    private Integer zhodaZas() {
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if (paska.isEmpty()) {
                return -1;
            }
            if (zasobnik.isEmpty()) {
                if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                        & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals("Z"))
                        & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals(paska.get(0)))) {
                    return i;
                }
            } else if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals(zasobnik.get(0)))
                    & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals(paska.get(0)))) {
                return i;
            }
        }
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if (zasobnik.isEmpty()) {
                return -1;
            }
            if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals(zasobnik.get(0)))
                    & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals("&"))) {
                return i;
            }
        }
        return -1;
    }

    /**
     * zapis edukacnej zlozky po vybere vykonavanej instrukcie
     * @param i vykonavana instrukcia
     */
    public Premenne simulaciaZasEduk(Premenne get, int i) {
        main = get;
        Boolean pom = true;
        if ((!paska.isEmpty()) & (zasobnik.isEmpty())) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals("Z"))
                    & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals(paska.get(0)))) {
                main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(i).getLine()
                        + main.lang.getText(32) + main.program.getStavRJ()
                        + main.lang.getText(33) + "Z"
                        + main.lang.getText(34) + paska.get(0));
                pom = false;
            }
        }
        if ((!paska.isEmpty()) & (zasobnik.isEmpty()) & pom) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals(zasobnik.get(0)))
                    & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals(paska.get(0)))) {
                main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(i).getLine()
                        + main.lang.getText(32) + main.program.getStavRJ()
                        + main.lang.getText(33) + zasobnik.get(0)
                        + main.lang.getText(34) + paska.get(0));
                pom = false;
            }
        }
        if ((!paska.isEmpty()) & (!zasobnik.isEmpty()) & pom) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getOneZnak2(0).contentEquals(zasobnik.get(0)))
                    & (main.program.getProgram().get(i).getOneZnak1(0).contentEquals("&"))) {
                main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(i).getLine()
                        + main.lang.getText(32) + main.program.getStavRJ()
                        + main.lang.getText(33) + zasobnik.get(0)
                        + main.lang.getText(34) + "&");
                return main;
            }
            main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(i).getLine()
                        + main.lang.getText(32) + main.program.getStavRJ()
                        + main.lang.getText(33) + zasobnik.get(0)
                        + main.lang.getText(34) + paska.get(0));
        }
        return main;
    }

    /**
     * naplnenie stringu pre potreby vyberu z duplicitnych instrukcii
     * @param a cislo referencnej instrukcie
     */
    public Premenne vyber(Premenne get,int a) {
        String str = String.valueOf(a) + ",  " + main.program.getProgram().get(a).getLine();
        int dupli = 0;
        for (int i = 0; i < main.program.getProgram().get(a).getDupli().size(); i++) {
            dupli = main.program.getProgram().get(a).getDupli().get(i);
            str = str + "\n" + String.valueOf(dupli) + ",  " + main.program.getProgram().get(dupli).getLine();
        }
        main.program.setVyberI(a);
        main.program.setVyberstr(str);
        return main;
    }

    /**
     * naplnenie vypisu pre okno pasky zasobnikoveho automatu
     */
    private void vypisPaskaZas() {
        List<String> vypis = new ArrayList();
        String p = "", z = "";
        for (int i = 0; i < paska.size(); i++) {
            if (i != (paska.size() - 1)) {
                p = p + paska.get(i) + ",";
            } else {
                p = p + paska.get(i);
            }
        }
        for (int j = 0; j < zasobnik.size(); j++) {
            if (j != (zasobnik.size() - 1)) {
                z = z + zasobnik.get(j) + ",";
            } else {
                z = z + zasobnik.get(j);
            }
        }
        vypis.add(0, main.program.getStavRJ());
        vypis.add(1, z);
        vypis.add(2, p);
        main.cache.setVypPasky(vypis);
    }

    /**
     * overenie ci je stav konecnym stavom
     * @return true ak je konecny stav
     */
    private Boolean isKonc() {
        Boolean is = false;
        List<String> kon = main.program.getKonStav();
        for (int i = 0; i < kon.size(); i++) {
            if (main.program.getStavRJ().contains(kon.get(i))) {
                is = true;
                break;
            }
        }
        return is;
    }

    /**
     * incializacia simulacie konecneho automatu
     */
    public Premenne simulaciaKonInit(Premenne get) {
        main = get;
        pozPredosla = 0;
        oneStep = false;
        zhoda = 0;
        main.zaznam.zaznam.clear();
        main.paska.getPozPasky().clear();
        main.paska.getPozPasky().add(0);


        main.program.setPrerus(false);
        mozny = true;
        main.program.setStavRJ(main.program.getZacStav());
        paska = main.paska.getPaska().get(0);

        vypisPaskaKon();
        return main;
    }

    /**
     * ziskanie vhodnej instukcie na pokracovanie v konecnom automate
     * @return cislo instrukcie
     */
    public Premenne simulaciaKonZhod(Premenne get) {
        main = get;
        mozny = false;
        zhoda = zhodaKon();
        main.program.setVyberI(zhoda);
        return main;
    }

    /**
     * spacovanie instrukcie pri konecnom automate
     */
    public Premenne simulaciaKonSprac(Premenne get) {
        main = get;
        oneStep = true;
        pozPredosla = main.paska.getPozPasky().get(0);
        zhoda = main.program.getVyberI();

        posunPaskyKon(zhoda);
        main.program.setStavRJ(main.program.getProgram().get(zhoda).getStav2());
        main.cache.setEdukLine(main.lang.getText(29) + main.program.getProgram().get(zhoda).getLine()
                + main.lang.getText(32) + main.program.getStavRJ());
        mozny = true;
        vypisPaskaKon();

        if ((main.paska.getPozPasky().get(0) < 0) || (main.paska.getPozPasky().get(0) >= paska.size())) {
            mozny = false;
        }
        return main;
    }

    /**
     * vyhodnotenie ukoncenia konecneho automatu
     */
    public Premenne simulaciaKonVyhod(Premenne get) {
        main = get;
        if (main.paska.getPozPasky().get(0) < 0) {
            main.cache.setErrLine(main.lang.getText(4));
            main.program.setSimOk(false);
        } else if ((!isKonc()) & (main.paska.getPozPasky().get(0) >= paska.size())) {
            main.cache.setErrLine(main.lang.getText(17));
            main.program.setSimOk(false);
        } else if (oneStep & isKonc() & (main.paska.getPozPasky().get(0) == (paska.size() - 1)) & (main.paska.getPozPasky().get(0) == pozPredosla)) {
            main.cache.setErrLine(main.lang.getText(15));
            main.program.setSimOk(true);
        } else if ((isKonc()) & (main.paska.getPozPasky().get(0) >= paska.size())) {
            main.cache.setErrLine(main.lang.getText(15));
            main.program.setSimOk(true);
        } else if (isKonc()) {
            main.cache.setErrLine(main.lang.getText(5));
            main.program.setSimOk(false);
        } else {
            main.cache.setErrLine(main.lang.getText(28));
            main.program.setSimOk(false);
        }
        return main;
    }

    /**
     * posum pasok pri spracovani instrukcie konecneho automatu
     * @param a cislo instrukcie
     */
    private void posunPaskyKon(int a) {
        int b = main.paska.getPozPasky().get(0);
        if (main.program.getProgram().get(a).getSmer().get(0).contains("l")) {
            b--;
        }
        if (main.program.getProgram().get(a).getSmer().get(0).contains("r")) {
            b++;
        }
        main.paska.getPozPasky().set(0, b);
    }

    /**
     * zistenie vhodnej instrukcie pre konecny automat
     * @return cislo vybranej instrukcie
     */
    private Integer zhodaKon() {
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ()))
                    & (main.program.getProgram().get(i).getZnak1().get(0).contentEquals(paska.get(main.paska.getPozPasky().get(0))))) {
                return i;
            }
        }
        return -1;
    }

    /**
     * naplnenie edukacnej zlozky pre konecny automat
     * @param i cislo spracovanej instrukcie
     */
    public Premenne simulaciaKonEduk(Premenne get, int i) {
        main = get;
        main.cache.setEdukLine(main.lang.getText(29) + main.program.getProgram().get(i).getLine()
                + main.lang.getText(30) + main.program.getStavRJ()
                + main.lang.getText(31) + paska.get(0));
        return main;
    }

    /**
     * nastavenie vypisu pasky pre konecny automat
     */
    private void vypisPaskaKon() {
        int pozHlavy = main.paska.getPozPasky().get(0);
        List<String> vypis = new ArrayList();
        int i = 0;
        String zac = "", stred = "", kon = "";
        for (i = 0; i < pozHlavy; i++) {
            if (i != (pozHlavy - 1)) {
                zac = zac + paska.get(i) + ",";
            } else {
                zac = zac + paska.get(i);
            }
        }
        if ((pozHlavy >= 0) & (pozHlavy < paska.size())) {
            stred = paska.get(pozHlavy);
        }
        for (i = (pozHlavy + 1); i < paska.size(); i++) {
            if (i != (pozHlavy + 1)) {
                kon = kon + "," + paska.get(i);
            } else {
                kon = paska.get(i);
            }
        }

        vypis.add(0, main.program.getStavRJ());
        vypis.add(1, zac);
        vypis.add(2, stred);
        vypis.add(3, kon);
        main.cache.setVypPasky(vypis);
    }

    /**
     * inicializacia simulacie pre turingov stroj
     */
    public Premenne simulaciaTurInit(Premenne get) {
        main = get;
        zhoda = 0;
        main.zaznam.zaznam.clear();

        main.program.setPrerus(false);
        mozny = true;
        main.program.setStavRJ(main.program.getZacStav());
        types = main.paska.getPaska();
        vypisPaskaTur();
        return main;
    }

    /**
     * zistenie pokracojucej instrukcie turingovho stroja
     * @return ceslo vybranej instrukcie
     */
    public Premenne simulaciaTurZhod(Premenne get) {
        main = get;
        mozny = false;
        zhoda = zhodaTur();
        main.program.setVyberI(zhoda);
        return main;
    }

    /**
     * spracovanie vybranej instrukcie turingovim strojom
     */
    public Premenne simulaciaTurSprac(Premenne get) {
        main = get;
        zhoda = main.program.getVyberI();
        naplnpaskyTur(zhoda);
        main.program.setStavRJ(main.program.getProgram().get(zhoda).getStav2());

        String str2 = "", str3 = "";
        for (int j = 0; j < main.program.getProgram().get(zhoda).getZnak2().size(); j++) {
            if (str2.isEmpty()) {
                str2 = main.program.getProgram().get(zhoda).getZnak2().get(j);
            } else {
                str2 = str2 + "," + main.program.getProgram().get(zhoda).getZnak2().get(j);
            }
        }
        for (int j = 0; j < main.program.getProgram().get(zhoda).getSmer().size(); j++) {
            if (str3.isEmpty()) {
                str3 = main.program.getProgram().get(zhoda).getSmer().get(j);
            } else {
                str3 = str3 + "," + main.program.getProgram().get(zhoda).getSmer().get(j);
            }
        }
        main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(zhoda).getLine()
                + main.lang.getText(34) + main.program.getStavRJ()
                + main.lang.getText(35) + str2
                + main.lang.getText(36) + str3);

        mozny = true;
        nastavSmerTur(zhoda);
        vypisPaskaTur();
        return main;
    }

    /**
     * vyhodnotenie ukoncenia turingovho stroja
     */
    public Premenne simulaciaTurVyhod(Premenne get) {
        main = get;
        if (isKonc()) {
            main.cache.setErrLine(main.lang.getText(15));
            main.program.setSimOk(true);
        } else {
            main.cache.setErrLine(main.lang.getText(28));
            main.program.setSimOk(false);
        }
        return main;
    }

    /**
     * zistenie kuska hlavy zodpovedajucej citacej hlave turingovho stroja
     * @param a cislo pasky
     * @return znak na konkretnom mieste
     */
    private String kusHlavyTur(int a) {
        int b = main.paska.getPozPasky().get(a);
        String znak = main.paska.getPaska().get(a).get(b).toString();
        return znak;
    }

    /**
     * naplnenie pasok pri spracovani instrukcie turingovho stroja
     * @param a cislo instrukcie
     */
    private void naplnpaskyTur(int a) {
        int b = 0;
        String c = "";
        for (int i = 0; i < main.program.getPasInt(); i++) {
            b = main.paska.getPozPasky().get(i);
            c = main.program.getProgram().get(a).getOneZnak2(i);
            main.paska.getPaska().get(i).set(b, c);
        }
    }

    /**
     * nastavenie posunu na paskach turingovho stroja
     * @param a ceslo instrujcie
     */
    private void nastavSmerTur(int a) {
        int b = 0;
        int c = 0;
        String d = "";
        for (int i = 0; i < main.program.getPasInt(); i++) {
            b = main.paska.getPozPasky().get(i);
            c = main.paska.getPaska().get(i).size();
            if (main.program.getProgram().get(a).getSmer().get(i).toLowerCase().trim().contentEquals("l")) {
                b--;
            }
            if (main.program.getProgram().get(a).getSmer().get(i).toLowerCase().trim().contentEquals("r")) {
                b++;
            }
            if (b == c) {
                main.paska.getPaska().get(i).add(c, "B");
                //JOptionPane.showMessageDialog(null, "Add B to the end. Tape="+main.paska.getPaska().get(i).toString());
            }
            if (b < 0) {
                main.paska.getPaska().get(i).add(c, "");
                //JOptionPane.showMessageDialog(null, "Adding element to end. Tape="+main.paska.getPaska().get(i).toString());
                for (int j = (c - 1); j > -1; j--) {    //by SKor: zmenene "j = (c - 2)" na "j = (c - 1)", inak pri TS mazal hodnotu posl. znaku pri vybehnuti na prazdnu bunku vlavo 
                    d = main.paska.getPaska().get(i).get(j).toString();
                    main.paska.getPaska().get(i).set(j + 1, d);
                }
                main.paska.getPaska().get(i).set(0, "B");
                //JOptionPane.showMessageDialog(null, "Add B to the beginning. Tape="+main.paska.getPaska().get(i).toString());

                b = 0;
            }
            main.paska.getPozPasky().set(i, b);
        }
    }

    /**
     * ziskanie vhodnej instrukcie na pokracovanie turingovho stroja
     * @return cislo instrukcie
     */
    private int zhodaTur() {
        Boolean pom = true;
        if (types.isEmpty()) {
            return -1;
        }
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            pom = true;
            if (main.program.getProgram().get(i).getStav1().contentEquals(main.program.getStavRJ())) {
                for (int j = 0; j < main.program.getPasInt(); j++) {
                    if (!main.program.getProgram().get(i).getZnak1().get(j).contentEquals(kusHlavyTur(j))) {
                        pom = false;
                        break;
                    }
                }
                if (pom) {
                    return i;
                }
            }
        }
        return -1;
    }

    /**
     * naplenie edukacnej zlozky turingovho stroja
     * @param i ceslo instrukcie
     */
    public Premenne simulaciaTurEduk(Premenne get, int i) {
        main = get;
        String str1 = "";
        for (int j = 0; j < main.program.getProgram().get(i).getZnak1().size(); j++) {
            if (str1.isEmpty()) {
                str1 = main.program.getProgram().get(i).getZnak1().get(j);
            } else {
                str1 = str1 + "," + main.program.getProgram().get(i).getZnak1().get(j);
            }
        }
        main.cache.setEdukLine(main.lang.getText(31) + main.program.getProgram().get(i).getLine()
                + main.lang.getText(32) + main.program.getStavRJ() + main.lang.getText(33) + str1);
        return main;
    }

    /**
     * vypis jednej pasky turingovho stroja
     * @param a poradove cislo pasky
     * @return list z jednotlivymi castami pasky
     */
    private List<String> vypisTapeTur(int a) {
        List<String> s = new ArrayList();
        int b = main.paska.getPozPasky().get(a);
        int c = main.paska.getPaska().get(a).size();
        String d = "", e = "", f = "", g = "";
        for (int i = 0; i < c; i++) {
            d = main.paska.getPaska().get(a).get(i).toString().trim();
            if (i < b) {
                e = e + d + ",";
            }
            if (i == b) {
                f = d;
            }
            if (i > b) {
                g = g + "," + d;
            }
        }
        s.add(0, e);
        s.add(1, f);
        s.add(2, g);
        return s;
    }

    /**
     * vypis pasky do okna turingovho stroja
     */
    private void vypisPaskaTur() {
        List<String> a = new ArrayList();
        List<String> b = new ArrayList();
        String c = "", d = "", e = "";
        for (int i = 0; i < main.program.getPasInt(); i++) {
            b = vypisTapeTur(i);
            if (i == (main.program.getPasInt() - 1)) {
                c = c + b.get(0);
                d = d + b.get(1);
                e = e + b.get(2);
            } else {
                c = c + b.get(0) + "\n";
                d = d + b.get(1) + "\n";
                e = e + b.get(2) + "\n";
            }
        }
        a.add(0, c);
        a.add(1, d);
        a.add(2, e);
        a.add(3, main.program.getStavRJ());
        main.cache.setVypPasky(a);
    }
}
