/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.model;

import java.util.ArrayList;
import java.util.List;

/**
 * objekt pre formalny popis instrukcie automatov
 * @author Stano
 */
public class Instrukcia {

    /** vstupny znak instrukcie */
    private List<String> znak1 = new ArrayList<String>();
    /** vystupny znak instrukcie */
    private List<String> znak2 = new ArrayList<String>();
    /** smer posunu */
    private List<String> smer = new ArrayList<String>();
    /** vstupny stav instrukcie */
    private String stav1 = null;
    /** vystupny stav instrukcie */
    private String stav2 = null;
    /** zaznam stringu instrukcie */
    private String line = null;
    /** zaznam o duplicite instrukcie */
    private List<Integer> dupli = new ArrayList<Integer>();
    /** novy top zazobnika */
    private String top = null;

    /**
     * konstruktor objektu triedy instrukcia
     */
    public Instrukcia() {
    }

    /**
     * @return the znak1
     */
    public List<String> getZnak1() {
        return znak1;
    }

    /**
     * @param znak1 the znak1 to set
     */
    public void setZnak1(List<String> znak1) {
        this.znak1 = znak1;
    }

    /**
     * @return the smer
     */
    public List<String> getSmer() {
        return smer;
    }

    /**
     * @param smer the smer to set
     */
    public void setSmer(List<String> smer) {
        this.smer = smer;
    }

    /**
     * @return the stav1
     */
    public String getStav1() {
        return stav1;
    }

    /**
     * @param stav1 the stav1 to set
     */
    public void setStav1(String stav1) {
        this.stav1 = stav1;
    }

    /**
     * @return the stav2
     */
    public String getStav2() {
        return stav2;
    }

    /**
     * @param stav2 the stav2 to set
     */
    public void setStav2(String stav2) {
        this.stav2 = stav2;
    }

    /**
     * @return the line
     */
    public String getLine() {
        return line;
    }

    /**
     * @param line the line to set
     */
    public void setLine(String line) {
        this.line = line;
    }

    /**
     * @return the dupli
     */
    public List<Integer> getDupli() {
        return dupli;
    }

    /**
     * @param dupli the dupli to set
     */
    public void setDupli(List<Integer> dupli) {
        this.dupli = dupli;
    }

    /**
     * @return the znak2
     */
    public List<String> getZnak2() {
        return znak2;
    }

    /**
     * @param znak2 the znak2 to set
     */
    public void setZnak2(List<String> znak2) {
        this.znak2 = znak2;
    }

    /**
     * @param znak pridanie jedneho znaku  pre znak1
     */
    public void addZnak1(String znak) {
        this.znak1.add(znak);
    }

    /**
     * @param znak pridanie jedneho znaku  pre znak2
     */
    public void addZnak2(String znak) {
        this.znak2.add(znak);
    }

    /**
     * @param i vyber znaku i zo znak1
     * @return vybrany string
     */
    public String getOneZnak1(int i) {
        if (i < 0 || i >= this.znak1.size()) {
            return "";
        }
        return this.znak1.get(i);
    }

    /**
     * @param i vyber znaku i zo znak2
     * @return vybrany string
     */
    public String getOneZnak2(int i) {
        if (i < 0 || i >= this.znak2.size()) {
            return "";
        }
        return this.znak2.get(i);
    }

    /**
     * @return the top
     */
    public String getTop() {
        return top;
    }

    /**
     * @param top the top to set
     */
    public void setTop(String top) {
        this.top = top;
    }
}
