/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.model;

import java.util.ArrayList;
import java.util.List;

/**
 * objekt zaznamu krokov pri simulacii
 * @author Stano
 */
public class Zaznam {

    /** pole zaznamu krokov simulacie */
    public List<Krok> zaznam = new ArrayList<Krok>();
    /** vyberany krok */
    private Integer krokI = 0;

    /**
     * konstruktor triedy zaznam
     */
    public Zaznam() {
    }

    /**
     * pridanie kroku do pola
     * @param krok vkladany krok
     */
    public void vlozZaznam(Krok krok) {
        zaznam.add(krok);
    }

    /**
     * nacitanie kroku zo zaznamu
     * @param por cislo vyziadaneho kroku
     * @return vybrany krok
     */
    public Krok nacitajZaznam(int por) {
        return zaznam.get(por);
    }

    /**
     * zistenie velkosti zaznamu
     * @return velkost zaznamu
     */
    public Integer size() {
        return zaznam.size();
    }

    /**
     * @return the krokI
     */
    public Integer getKrokI() {
        return krokI;
    }

    /**
     * @param krokI the krokI to set
     */
    public void setKrokI(Integer krokI) {
        this.krokI = krokI;
    }
}
