<?php  // $Id: upgrade.php,v 1.1.10.1 2007/11/02 16:20:39 tjhunt Exp $

// This file keeps track of upgrades to 
// the shortanswer qtype plugin
//
// Sometimes, changes between versions involve
// alterations to database structures and other
// major things that may break installations.
//
// The upgrade function in this file will attempt
// to perform all the necessary actions to upgrade
// your older installtion to the current version.
//
// If there's something it cannot do itself, it
// will tell you what you need to do.
//
// The commands in here will all be database-neutral,
// using the functions defined in lib/ddllib.php

function xmldb_qtype_abstraktne_upgrade($oldversion=0) {

    global $CFG, $THEME, $db;

    $result = true;

/// And upgrade begins here. For each one, you'll need one 
/// block of code similar to the next one. Please, delete 
/// this comment lines once this file start handling proper
/// upgrade code.

/// if ($result && $oldversion < 2009101530) { //New version in version.php
///     $result = result of "/lib/ddllib.php" function calls
/// }
    if ($result && $oldversion < 2009101570) {

    /// Define table question_abstraktne to be created
        $table = new XMLDBTable('question_abstraktne');

    /// Adding fields to table question_abstraktne
        $table->addFieldInfo('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null, null, null);
        $table->addFieldInfo('question', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0');
        $table->addFieldInfo('nazov_suboru', XMLDB_TYPE_CHAR, '255', null, XMLDB_NOTNULL, null, null, null, null);
        $table->addFieldInfo('hod_data', XMLDB_TYPE_TEXT, null, null, XMLDB_NOTNULL, null, null, null, null);

    /// Adding keys to table question_abstraktne
        $table->addKeyInfo('primary', XMLDB_KEY_PRIMARY, array('id'));
        $table->addKeyInfo('question', XMLDB_KEY_FOREIGN, array('question'), 'questions', array('id'));

    /// Launch create table for question_abstraktne
        $result = $result && create_table($table);
    }

    return $result;
}

?>
