<?php

/*
 * volanie websluzby
 * abstraktne
 */

class Call_wsEvaluate{
    
    var $hodnota="";
    
    /**
     * @param $answer - string with the answer from the test
     * @param $data - settings for machine
     * @param $mode - mode of evaluating web service 0 - evaluate 1 - control only    
     */         
    function __construct($answer, $data, $mode) {
        
        $key = md5("modul_astraktne@");
      
        $opts = array(
            'ssl' => array('ciphers'=>'RC4-SHA')
        );
        
        ini_set( "soap.wsdl_cache_enabled", "0" );
            
        
                     
        $client = new SoapClient("https://localhost:4848/KpiEasWeb/EvaluateAnswerWS?wsdl"
        ,array(
            "encoding"=>"ISO-8859-1",
            'stream_context' => stream_context_create($opts),
            "trace"=>1,
            "exceptions"=>0,
            "connection_timeout"=>2000
            )
        );
        
      

        $resultSluzby = $client->evaluate(array(
            "instrukcieStudenta"=> $answer,
            "kontrData"=> $data,
            "mode"=> $mode,
            "key"=> $key
            )
        );
        
           
         
            
            
            $vysledok = $resultSluzby->return;
            $this->hodnota=$vysledok;
    } 
}
?>