/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.abstraktne;

import java.util.ArrayList;
import java.util.List;

/**
 * trieda zodpovedna za spravne nastavenie jazyka aplikacie
 * @author Stano
 */
public class Language {

    /** zoznam textov hlasenia strojov */
    private List<String> text = new ArrayList<String>();
    /** zoznam textov pre okna a tlacidla */
    private List<String> other = new ArrayList<String>();

    /**
     * konstruktor triedy Language
     */
    public Language() {
    }

    /**
     * nastavenie jazykoveho rozhrania
     * @param typ parameter typu stroja
     * @param state patameter vybraneho jazyka
     */
    public void setLang(Integer typ, Integer state) {
        if (typ == 1 & state == 1) {
            setTurSk();
        }
        if (typ == 1 & state == 2) {
            setTurEng();
        }
        if (typ == 2 & state == 1) {
            setZasobSk();
        }
        if (typ == 2 & state == 2) {
            setZasobEng();
        }
        if (typ == 3 & state == 1) {
            setKonSk();
        }
        if (typ == 3 & state == 2) {
            setKonEng();
        }

    }

    /**
     * metoda pre ziskanie zaznamu pre tlacidla a okna
     * @param por cislo zaznamu
     * @return vybrany zaznam
     */
    public String getOther(Integer por) {
        if ((por >= other.size()) || (por < 0)) {
            return por + ". Other Error! " + other.size();
        } else {
            return other.get(por);
        }
    }

    /**
     * metoda pre ziskanie zaznamu hlasenia
     * @param por cislo zaznamu
     * @return vybrany zaznam
     */
    public String getText(Integer por) {
        if ((por >= text.size()) || (por < 0)) {
            return por + ". Text Error! size: " + text.size() + " ";
        } else {
            return text.get(por);
        }
    }

    /**
     * nastavenie slovenskeho jazyka pre zasobnikovy automat
     */
    private void setZasobSk() {

        other.clear();
        other.add(0, "Zásobníkový automat");
        other.add(1, "Inštrukcia :");
        other.add(2, "Program :");
        other.add(3, "Páska :");
        other.add(4, "Zásobník :");
        other.add(5, "Začiatočný stav :");
        other.add(6, "Koncový stav :");
        other.add(7, "Stav :");
        other.add(8, "Záznam :");
        other.add(9, "Režim :");
        other.add(10, "Náhodne");
        other.add(11, "Oba");
        other.add(12, "Stav");
        other.add(13, "Zásobník");
        other.add(14, "Ulož");
        other.add(15, "Načítaj");
        other.add(16, "Zmaž");
        other.add(17, "Prerušenie");
        other.add(18, "Simulácia");
        other.add(19, "Kontrola");

        text.clear();
        text.add(0, "Nieje zadaný žiaden program !");
        text.add(1, "Páska je prázdna !");
        text.add(2, "Niesu zadané vstupné hodnoty !");
        text.add(3, "Zrušenie výberu súboru !");
        text.add(4, "Chybný nový vrchol zásobníka v riadku :  ");
        text.add(5, "Program dosiahol koncový stav.");
        text.add(6, "Chyba pri nahrávaní programu !");
        text.add(7, "Táto inštrukcia je príliš dlhá : ");
        text.add(8, "Táto inštrukcia neobsahuje všetky údaje : ");
        text.add(9, "Chybný prvý stav v riadku :  ");
        text.add(10, "Chybný starý vrchol zásobníka v riadku :  ");
        text.add(11, "Chybný druhý stav v riadku :  ");
        text.add(12, "Program vyprázdnil zásobník.");
        text.add(13, "Prázdny znak zásobníka !");
        text.add(14, "Chybný znak zásobníka !");
        text.add(15, "Program prebehol v poriadku.");
        text.add(16, "Prázdny znak pásky !");
        text.add(17, "Chyba pri načítavaní zásobníka !");
        text.add(18, "Uloženie programu ZA");
        text.add(19, "Záznam  ");
        text.add(20, "  je duplicitný !");
        text.add(21, "Chyba pri načítavaní pásky !");
        text.add(22, "Chyba pri ukladaní pásky !");
        text.add(23, "Chyba pri ukladaní programu !");
        text.add(24, "Chyba pri ukladaní zasobníka !");
        text.add(25, "Chybný znak pásky :  ");
        text.add(26, "OK");
        text.add(27, "Program bol prerušený !");
        text.add(28, "Program neprebehol v poriadku !");
        text.add(29, "Zrušiť");
        text.add(30, "Vyberte požadovanú inštrukciu :");
        text.add(31, "Vybraná inštrukcia ");
        text.add(32, " => stav stroja je ");
        text.add(33, ", vrchol zásobnika je ");
        text.add(34, " a znak vstupu ");
        text.add(35, ", stav sa mení na ");
        text.add(36, " a vrchol zásobníka na ");
        text.add(37, "Načítanie programu ZA");
        text.add(38, "Uloženie pásky ZA");
        text.add(39, "Načítanie pásky ZA");
        text.add(40, "Uloženie zásobníka ZA");
        text.add(41, "Načítanie zásobníka ZA");
        text.add(42, "Výber Inštrukcie");
    }

    /**
     * nastavenie anglickeho jazyka pre zasobnikovy automat
     */
    private void setZasobEng() {
        other.clear();
        other.add(0, "Pushdown automaton");
        other.add(1, "Instruction :");
        other.add(2, "Program :");
        other.add(3, "Type :");
        other.add(4, "Pushdown :");
        other.add(5, "Initial state :");
        other.add(6, "Final state :");
        other.add(7, "State :");
        other.add(8, "Record :");
        other.add(9, "Mode :");
        other.add(10, "Random");
        other.add(11, "Both");
        other.add(12, "State");
        other.add(13, "Pushdown");
        other.add(14, "Save");
        other.add(15, "Load");
        other.add(16, "Delete");
        other.add(17, "Break");
        other.add(18, "Simulation");
        other.add(19, "Control");

        text.clear();
        text.add(0, "There isn't any program !");
        text.add(1, "The tape is empty !");
        text.add(2, "There aren't any input values !");
        text.add(3, "Repeal file selection !");
        text.add(4, "Wrong new top of a pushdown in the line :  ");
        text.add(5, "The program attain to final state.");
        text.add(6, "Error of loading the program !");
        text.add(7, "This instruction is too long : ");
        text.add(8, "This instruction doesn't contain all of the information : ");
        text.add(9, "Wrong the first state in the row :  ");
        text.add(10, "Wrong old top of pushdown in the line :  ");
        text.add(11, "Wrong second state in the row :  ");
        text.add(12, "The program emptied pushdown.");
        text.add(13, "Empty character of pushdown !");
        text.add(14, "Wrong character of pushdown :  ");
        text.add(15, "The program was conducted in order.");
        text.add(16, "Empty character of the tape !");
        text.add(17, "Error of loading the pushdown !");
        text.add(18, "Save program PA");
        text.add(19, "Record  ");
        text.add(20, "  is a duplicate !");
        text.add(21, "Error of loading the tape !");
        text.add(22, "Error of saving tape !");
        text.add(23, "Error of saving program !");
        text.add(24, "Error of saving pushdown !");
        text.add(25, "Wrong character of tape :  ");
        text.add(26, "OK");
        text.add(27, "The program has been interrupted !");
        text.add(28, "The program wasn't conducted in order !");
        text.add(29, "Cancel");
        text.add(30, "Select the desired instruction :");
        text.add(31, "Selected instruction ");
        text.add(32, " => state of machine is ");
        text.add(33, ", top of pushdown is ");
        text.add(34, " and symbol of input ");
        text.add(35, ", state is changed to ");
        text.add(36, " and top pushdown to ");
        text.add(37, "Load program PA");
        text.add(38, "Save type PA");
        text.add(39, "Load type PA");
        text.add(40, "Save pushdown PA");
        text.add(41, "Load pushdown PA");
        text.add(42, "Selection Instruction");
    }

    /**
     * nastavenie slovenskeho jazyka pre konecny automat
     */
    private void setKonSk() {
        other.clear();
        other.add(0, "Konečný automat");
        other.add(1, "Inštrukcia :");
        other.add(2, "Program :");
        other.add(3, "Páska :");
        other.add(4, "Začiatočný stav :");
        other.add(5, "Koncový stav :");
        other.add(6, "Stav :");
        other.add(7, "Záznam :");
        other.add(8, "Náhodne");
        other.add(9, "Ulož");
        other.add(10, "Načítaj");
        other.add(11, "Zmaž");
        other.add(12, "Prerušenie");
        other.add(13, "Simulácia");
        other.add(14, "Kontrola");

        text.clear();
        text.add(0, "Nieje zadaný žiaden program !");
        text.add(1, "Páska je prázdna !");
        text.add(2, "Niesu zadané vstupné hodnoty !");
        text.add(3, "Zrušenie výberu súboru !");
        text.add(4, "Program neprebehol v poriadku, prekročil ľavý okraj pásky !");
        text.add(5, "Program dosiahol koncový stav ale neprešiel celú pásku !");
        text.add(6, "Chyba pri nahrávaní programu !");
        text.add(7, "Táto inštrukcia je príliš dlhá : ");
        text.add(8, "Táto inštrukcia neobsahuje všetky údaje : ");
        text.add(9, "Chybný prvý stav v riadku :  ");
        text.add(10, "Chybný starý vrchol zásobníka v riadku :  ");
        text.add(11, "Chybný druhý stav v riadku :  ");
        text.add(12, "Chybný vstup : ");
        text.add(13, "Chybný smer : ");
        text.add(14, "Vyberte požadovanú inštrukciu :");
        text.add(15, "Program prebehol v poriadku.");
        text.add(16, "Prázdny znak pásky !");
        text.add(17, "Program prešiel celým slovom ale nedosiahol konečný stav !");
        text.add(18, "Uloženie programu KA");
        text.add(19, "Záznam  ");
        text.add(20, "  je duplicitný !");
        text.add(21, "Chyba pri načítavaní pásky !");
        text.add(22, "Chyba pri ukladaní pásky !");
        text.add(23, "Chyba pri ukladaní programu !");
        text.add(24, "Zrušiť");
        text.add(25, "Chybný znak pásky :  ");
        text.add(26, "OK");
        text.add(27, "Program bol prerušený !");
        text.add(28, "Program neprebehol v poriadku !");
        text.add(29, "Vybraná inštrukcia ");
        text.add(30, " => stav stroja je ");
        text.add(31, " a porovnávací znak  ");
        text.add(32, ", stav sa mení na ");
        text.add(33, "");
        text.add(34, "");
        text.add(35, "");
        text.add(36, "");
        text.add(37, "Načítanie programu KA");
        text.add(38, "Uloženie pásky KA");
        text.add(39, "Načítanie pásky KA");
        text.add(40, "");
        text.add(41, "");
        text.add(42, "Výber Inštrukcie");

    }

    /**
     * nastavenie anglickeho jazyka pre konecny automat
     */
    private void setKonEng() {
        other.clear();
        other.add(0, "Finite-state machine");
        other.add(1, "Instruction :");
        other.add(2, "Program :");
        other.add(3, "Tape :");
        other.add(4, "Initial state :");
        other.add(5, "Final state :");
        other.add(6, "State :");
        other.add(7, "Record :");
        other.add(8, "Random");
        other.add(9, "Save");
        other.add(10, "Load");
        other.add(11, "Delete");
        other.add(12, "Break");
        other.add(13, "Simulation");
        other.add(14, "Control");

        text.clear();
        text.add(1, "The tape is empty !");
        text.add(2, "There aren't any input values !");
        text.add(3, "Repeal file selection !");
        text.add(4, "The program wasn't conducted in order, crossed the left edge of the tape !");
        text.add(5, "The program attain to final state but didn't pass full tape !");
        text.add(6, "Error of loading the program !");
        text.add(7, "This instruction is too long : ");
        text.add(8, "This instruction doesn't contain all of the information : ");
        text.add(9, "Wrong the first state in the row :  ");
        text.add(10, "Wrong old top of buffer in the line :  ");
        text.add(11, "Wrong second state in the row :  ");
        text.add(12, "Wrong input : ");
        text.add(13, "Wrong direction : ");
        text.add(14, "Select the desired instruction :");
        text.add(15, "The program was conducted in order.");
        text.add(16, "Empty character of the tape !");
        text.add(17, "The program went through the whole word but hasn't reached a final state !");
        text.add(18, "Save program F-SM");
        text.add(19, "Record  ");
        text.add(20, "  is a duplicate !");
        text.add(21, "Error of loading the tape !");
        text.add(22, "Error of saving tape !");
        text.add(23, "Error of saving program !");
        text.add(24, "Cancel");
        text.add(25, "Wrong character of tape :  ");
        text.add(26, "OK");
        text.add(27, "The program has been interrupted !");
        text.add(28, "The program wasn't conducted in order !");
        text.add(29, "Selected instruction ");
        text.add(30, " => state of machine is ");
        text.add(31, " and comparative symbol ");
        text.add(32, ", state is changed to ");
        text.add(33, "");
        text.add(34, "");
        text.add(35, "");
        text.add(36, "");
        text.add(37, "Load program F-SM");
        text.add(38, "Save type F-SM");
        text.add(39, "Load type F-SM");
        text.add(40, "");
        text.add(41, "");
        text.add(42, "Selection Instruction");
    }

    /**
     * nastavenie slovenskeho jazyka pre turingov stroj
     */
    private void setTurSk() {

        other.clear();
        other.add(0, "Turingov stroj");
        other.add(1, "Inštrukcia :");
        other.add(2, "Program :");
        other.add(3, "Páska :");
        other.add(4, "Začiatočný stav :");
        other.add(5, "Koncový stav :");
        other.add(6, "Stav :");
        other.add(7, "Záznam :");
        other.add(8, "Náhodne");
        other.add(9, "Ulož");
        other.add(10, "Načítaj");
        other.add(11, "Zmaž");
        other.add(12, "Prerušenie");
        other.add(13, "Simulácia");
        other.add(14, "Kontrola");
        other.add(15, "Index pásky :");
        other.add(16, "Viac pások");

        text.clear();
        text.add(0, "Nieje zadaný žiaden program !");
        text.add(1, "Páska je prázdna !");
        text.add(2, "Niesu zadané vstupné hodnoty !");
        text.add(3, "Zrušenie výberu súboru !");
        text.add(4, "Znak indexu na páske musí byť číslo !");
        text.add(5, "Index pásky je mimo limít !");
        text.add(6, "Chyba pri nahrávaní programu !");
        text.add(7, "Táto inštrukcia je príliš dlhá : ");
        text.add(8, "Táto inštrukcia neobsahuje všetky údaje : ");
        text.add(9, "Chybný prvý stav v riadku :  ");
        text.add(10, "Chybný počet pások v indexe !");
        text.add(11, "Chybný druhý stav v riadku :  ");
        text.add(12, "Chybne zadaný smer v riadku :  ");
        text.add(13, "Chýbajúce zátvorky v riadku :  ");
        text.add(14, "Chybné pásky v riadku :  ");
        text.add(15, "Program prebehol v poriadku.");
        text.add(16, "Prázdny znak pásky !");
        text.add(17, "Chybný počet pások v riadku :  ");
        text.add(18, "Uloženie programu TS");
        text.add(19, "Záznam  ");
        text.add(20, "  je duplicitný !");
        text.add(21, "Chyba pri načítavaní pásky !");
        text.add(22, "Chyba pri ukladaní pásky !");
        text.add(23, "Chyba pri ukladaní programu !");
        text.add(24, "Chýbajúce zátvorky :  ");
        text.add(25, "Chybný znak pásky :  ");
        text.add(26, "Chybný počet pások :  ");
        text.add(27, "Program bol prerušený !");
        text.add(28, "Program nedosiahol konečný stav !");
        text.add(29, "Zrušiť");
        text.add(30, "OK");
        text.add(31, "Vybraná inštrukcia ");
        text.add(32, " => stav stroja je ");
        text.add(33, " a stav pások  ");
        text.add(34, ", stav sa mení na ");
        text.add(35, ", pásky sa menia na ");
        text.add(36, " a nastáva posun pások ");
        text.add(37, "Načítanie programu TS");
        text.add(38, "Uloženie pásky TS");
        text.add(39, "Načítanie pásky TS");
        text.add(40, "Vyberte požadovanú inštrukciu :");
        text.add(41, "");
        text.add(42, "Výber Inštrukcie");
    }

    /**
     * nastavenie anglickeho jazyka pre turingov stroj
     */
    private void setTurEng() {

        other.clear();
        other.add(0, "Turing machine");
        other.add(1, "Instruction :");
        other.add(2, "Program :");
        other.add(3, "Tape :");
        other.add(4, "Initial state :");
        other.add(5, "Final state :");
        other.add(6, "State :");
        other.add(7, "Record :");
        other.add(8, "Random");
        other.add(9, "Save");
        other.add(10, "Load");
        other.add(11, "Delete");
        other.add(12, "Break");
        other.add(13, "Simulation");
        other.add(14, "Control");
        other.add(15, "Tape index :");
        other.add(16, "More tapes");

        text.clear();
        text.add(0, "There isn't any program !");
        text.add(1, "The tape is empty !");
        text.add(2, "There aren't any input values !");
        text.add(3, "Repeal file selection !");
        text.add(4, "The character of index on the tape must be a number !");
        text.add(5, "Index of the tape is out of the limit !");
        text.add(6, "Error of loading the program !");
        text.add(7, "This instruction is too long : ");
        text.add(8, "This instruction doesn't contain all of the information : ");
        text.add(9, "Wrong the first state in the row :  ");
        text.add(10, "Wrong number of tapes in the index !");
        text.add(11, "Wrong second state in the row :  ");
        text.add(12, "Wrong specified direction in the line :  ");
        text.add(13, "Missing parenthesis in the line :  ");
        text.add(14, "Defective tapes in the line :  ");
        text.add(15, "The program was conducted in order .");
        text.add(16, "Empty character the tape !");
        text.add(17, "Wrong number of tapes in the line :  ");
        text.add(18, "Save program TM");
        text.add(19, "Record  ");
        text.add(20, "  is a duplicate !");
        text.add(21, "Error of loading the tape !");
        text.add(22, "Error of saving tape !");
        text.add(23, "Error of saving program !");
        text.add(24, "Missing parenthesis :  ");
        text.add(25, "Wrong character of tape :  ");
        text.add(26, "Wrong number of tapes :  ");
        text.add(27, "The program has been interrupted !");
        text.add(28, "The program hasn't reached the final state !");
        text.add(29, "Cancel");
        text.add(30, "OK");
        text.add(31, "Selected instruction ");
        text.add(32, " => state of machine is ");
        text.add(33, " and state of types  ");
        text.add(34, ", state is changed to ");
        text.add(35, ", types are changed to ");
        text.add(36, " and there is a shift tape ");
        text.add(37, "Load program TM");
        text.add(38, "Save type TM");
        text.add(39, "Load type TM");
        text.add(40, "Select the desired instruction :");
        text.add(41, "");
        text.add(42, "Selection Instruction");
    }
}
