/*
 * AbstraktneApp.java
 */
package sk.tuke.fei.KpiEas.abstraktne;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;
import sk.tuke.fei.KpiEas.view.UvodView;

/**
 * Hlavna trieda aplikacie.
 */
public class Main extends SingleFrameApplication {

    /** instancia aplikacie */
    private static Main instance = null;
    public static Premenne prem = new Premenne();

    /**
     * spustenie hlavneho framu okna
     */
    @Override
    protected void startup() {
        show(new UvodView());
    }

    /**
     * inicializacna metoda pre spustenie aplikacie
     * @param root parameter okna
     */
    @Override
    protected void configureWindow(java.awt.Window root) {
    }

    /**
     * metoda pre ziskanie aplikacie
     * @return aplikacia
     */
    public static Main getApplication() {
        return Application.getInstance(Main.class);
    }

    /**
     * metoda pre zacatie aplikacie
     * @param args startovaci argument
     */
    public static void main(String[] args) {
        launch(Main.class, args);
    }

    /**
     * metoda pre ziskanie instancie triedy main
     * @return instancia triedy main
     */
    public static Main getInst() {
        if (instance == null) {
            instance = new Main();
        }
        return instance;
    }
}
