/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.abstraktne;

import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * vlakno na simulaciu strojov v grafickej forme
 * @author Stano
 */
public class Vlakno extends Thread {

    private Premenne main = Main.prem;
    /** premenna nahodnych prememnych */
    private Random random = new Random();

    /**
     * inicializacna metoda pre vlakno
     */
    @Override
    public void run() {
        while (true) {
            if (main.program.getTyp() == 1) simViewTur();
            if (main.program.getTyp() == 2) simViewZas();
            if (main.program.getTyp() == 3) simViewKon();
            if (main.program.getPrerus()) {
                return;
            }
        }
    }

    /**
     * simulacia zasobnikoveho automatu
     */
    private void simViewZas() {
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        int time = 0;
        main.zasobView.cleanOkno();
        main.zasobView.pristupOkno(false);
        main = sim.simulaciaZasInit(main);
        main.zasobView.setSimul(main.cache.getVypPasky());

        while (sim.mozny) {
            time = 0;
            main = sim.simulaciaZasZhod(main);
            int zhoda = main.program.getVyberI();
            if (zhoda != -1) {
                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & !main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberbool(true);
                    new sk.tuke.fei.KpiEas.view.VyberDialog(main.zasobView, true).setVisible(true);
                    while (main.program.getVyberbool()) {
                    }
                    zhoda = main.program.getVyberI();
                    main.zasobView.setVisible(true);
                    time = 1;
                }
                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberI(random());
                    zhoda = main.program.getVyberI();
                }
                main = sim.simulaciaZasEduk(main, zhoda);
                main.zasobView.setEduk(main.cache.getEdukLine());

                if (main.program.getPrerus()) {
                    main.cache.setErrLine(main.lang.getText(27));
                    main.zasobView.setErr();
                    main.program.setPrerus(false);
                    sim.mozny = false;
                    time = 1;
                    break;
                }

                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.zasobView.setRunInst(zhoda);
                main = sim.simulaciaZasSprac(main);
                main.zasobView.setEduk(main.cache.getEdukLine());
                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.zasobView.setSimul(main.cache.getVypPasky());
            }

            if (!sim.mozny) {
                main = sim.simulaciaZasVyhod(main);
                main.zasobView.setErr();
                break;
            }
        }
        main.zasobView.zacnas();
        main.zasobView.setErr();
        main.program.setPrerus(true);
    }

    /**
     * simulacia konecneho automatu
     */
    private void simViewKon() {
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        int time = 0;
        main.konView.cleanOkno();
        main.konView.pristupOkno(false);
        main = sim.simulaciaKonInit(main);
        main.konView.setSimul(main.cache.getVypPasky());

        while (sim.mozny) {
            time = 0;
            main = sim.simulaciaKonZhod(main);
            int zhoda = main.program.getVyberI();
            if (zhoda != -1) {
                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & !main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberbool(true);
                    new sk.tuke.fei.KpiEas.view.VyberDialog(main.konView, true).setVisible(true);
                    while (main.program.getVyberbool()) {
                    }
                    zhoda = main.program.getVyberI();
                    main.konView.setVisible(true);
                    time = 1;
                }

                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberI(random());
                    zhoda = main.program.getVyberI();
                }
                main = sim.simulaciaKonEduk(main, zhoda);
                main.konView.setEduk(main.cache.getEdukLine());

                if (main.program.getPrerus()) {
                    main.cache.setErrLine(main.lang.getText(27));
                    main.konView.setErr();
                    main.program.setPrerus(false);
                    sim.mozny = false;
                    time = 1;
                    break;
                }

                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.konView.setRunInst(zhoda);
                main = sim.simulaciaKonSprac(main);
                main.konView.setEduk(main.cache.getEdukLine());
                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.konView.setSimul(main.cache.getVypPasky());
            }

            if (!sim.mozny) {
                main = sim.simulaciaKonVyhod(main);
                main.konView.setErr();
                break;
            }
        }
        main.konView.zacnas();
        main.konView.setErr();
        main.program.setPrerus(true);
    }

    /**
     * simulacia turingoveho stroja
     */
    private void simViewTur() {
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        int time = 0;
        main.turingView.cleanOkno();
        main.turingView.pristupOkno(false);
        main = sim.simulaciaTurInit(main);
        main.turingView.setPasky(main.cache.getVypPasky());

        while (sim.mozny) {
            time = 0;
            main = sim.simulaciaTurZhod(main);
            int zhoda = main.program.getVyberI();
            if (zhoda != -1) {
                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & !main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberbool(true);
                    new sk.tuke.fei.KpiEas.view.VyberDialog(main.turingView, true).setVisible(true);
                    while (main.program.getVyberbool()) {
                    }
                    zhoda = main.program.getVyberI();
                    main.turingView.setVisible(true);
                    time = 1;
                }
                if (!main.program.getProgram().get(zhoda).getDupli().isEmpty() & main.program.getNahodne()) {
                    main = sim.vyber(main, zhoda);
                    main.program.setVyberI(random());
                    zhoda = main.program.getVyberI();
                }

                main = sim.simulaciaTurEduk(main, zhoda);
                main.turingView.setEduk(main.cache.getEdukLine());

                if (main.program.getPrerus()) {
                    main.cache.setErrLine(main.lang.getText(27));
                    main.turingView.setErr();
                    main.program.setPrerus(false);
                    sim.mozny = false;
                    break;
                }
                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.turingView.setRunInst(zhoda);
                main = sim.simulaciaTurSprac(main);
                main.turingView.setEduk(main.cache.getEdukLine());
                if (time == 0) {
                    try {
                        sleep(400);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Vlakno.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                main.turingView.setPasky(main.cache.getVypPasky());

            }
            if (!sim.mozny) {
                main = sim.simulaciaTurVyhod(main);
                main.turingView.setErr();
                break;
            }
        }
        main.turingView.zacnas();
        main.turingView.setErr();
        main.program.setPrerus(true);
    }

    /**
     * automaticky vyber instrukcie pri viacerych moznostiach
     * @return cislo vybranej instrukcie
     */
    private int random() {
        String[] vyber = main.program.getVyberstr().split("\n");
        int r = random.nextInt(vyber.length);
        String[] split = vyber[r].split(",");
        int i = Integer.parseInt(split[0]);
        return i;
    }
}
