/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.model;

import java.util.ArrayList;
import java.util.List;

/**
 * objekt uchovavajuci formatovany program ako aj data potrebne k chodu programu
 * @author Stano
 */
public class Program {

    /** stav riadiacej jednotky */
    private String stavRJ = null;
    /** zaciatocny stav automatov */
    private String zacStav = null;
    /** zoznam koncovych stavov */
    private List<String> konStav = new ArrayList<String>();
    /** zaznam programu vo formatovanej podobe */
    private List<sk.tuke.fei.KpiEas.model.Instrukcia> program = new ArrayList<sk.tuke.fei.KpiEas.model.Instrukcia>();
    /** typ automatu konecny, zobnikovy automat alebo turingov stroj */
    private Integer typ = 0;
    /** nastavenie sposobu ukoncenia pri zasobnikovom automate */
    private Integer mode = 0;
    /** informacia o stlaceni tlacidla prerusenie programu */
    private Boolean prerus = false;
    /** zaznam o uspesnosti vyberu pri duplicite */
    private Boolean vyberbool = false;
    /** vybrana informacia pri duplicite */
    private Integer vyberI = 0;
    /** string pre nastaveni vyberu pri duplicite */
    private String vyberstr = null;
    /** zaznam o nastaveni nahodneho vyberu pri duplicite */
    private Boolean nahodne = false;
    /** zaznam o nastavanialebo nenastavani viacpaskoveho turingoveho stroja */
    private Boolean viacPas = false;
    /** referencny pocet pasok vo viacpaskovom turingocom stroji */
    private Integer pasInt = 0;
    /** pocet testov na program zadany cez service */
    private Integer pocetTestov = 0;
    /** vyhodnotenie service simulacie */
    private Boolean simOk = false;
    /** potvrdenie vidialeneho spustania */
    private Boolean service = false;

    /**
     * konstruktor objektu program
     */
    public Program() {
    }

    /**
     * @return the zacStav
     */
    public String getZacStav() {
        return zacStav;
    }

    /**
     * @param zacStav the zacStav to set
     */
    public void setZacStav(String zacStav) {
        this.zacStav = zacStav;
    }

    /**
     * @return the program
     */
    public List<sk.tuke.fei.KpiEas.model.Instrukcia> getProgram() {
        return program;
    }

    /**
     * @param program the program to set
     */
    public void setProgram(List<sk.tuke.fei.KpiEas.model.Instrukcia> program) {
        this.setProgram(program);
    }

    /**
     * @return the typ
     */
    public Integer getTyp() {
        return typ;
    }

    /**
     * @param typ the typ to set
     */
    public void setTyp(Integer typ) {
        this.typ = typ;
    }

    /**
     * @return the mode
     */
    public Integer getMode() {
        return mode;
    }

    /**
     * @param mode the mode to set
     */
    public void setMode(Integer mode) {
        this.mode = mode;
    }

    /**
     * @return the prerus
     */
    public Boolean getPrerus() {
        return prerus;
    }

    /**
     * @param prerus the prerus to set
     */
    public void setPrerus(Boolean prerus) {
        this.prerus = prerus;
    }

    /**
     * @return the vyberbool
     */
    public Boolean getVyberbool() {
        return vyberbool;
    }

    /**
     * @param vyberbool the vyberbool to set
     */
    public void setVyberbool(Boolean vyberbool) {
        this.vyberbool = vyberbool;
    }

    /**
     * @return the vyberI
     */
    public Integer getVyberI() {
        return vyberI;
    }

    /**
     * @param vyberI the vyberI to set
     */
    public void setVyberI(Integer vyberI) {
        this.vyberI = vyberI;
    }

    /**
     * @return the vyberstr
     */
    public String getVyberstr() {
        return vyberstr;
    }

    /**
     * @param vyberstr the vyberstr to set
     */
    public void setVyberstr(String vyberstr) {
        this.vyberstr = vyberstr;
    }

    /**
     * @return the nahodne
     */
    public Boolean getNahodne() {
        return nahodne;
    }

    /**
     * @param nahodne the nahodne to set
     */
    public void setNahodne(Boolean nahodne) {
        this.nahodne = nahodne;
    }

    /**
     * @return the konStav
     */
    public List<String> getKonStav() {
        return konStav;
    }

    /**
     * @param konStav the konStav to set
     */
    public void setKonStav(List<String> konStav) {
        this.konStav = konStav;
    }

    /**
     * @return the viacPas
     */
    public Boolean getViacPas() {
        return viacPas;
    }

    /**
     * @param viacPas the viacPas to set
     */
    public void setViacPas(Boolean viacPas) {
        this.viacPas = viacPas;
    }

    /**
     * @return pocet pasok
     */
    public Integer getPasInt() {
        return pasInt;
    }

    /**
     * @param pasInt pocet pasok
     */
    public void setPasInt(Integer pasInt) {
        this.pasInt = pasInt;
    }

    /**
     * @return the pocetTestov
     */
    public Integer getPocetTestov() {
        return pocetTestov;
    }

    /**
     * @param pocetTestov the pocetTestov to set
     */
    public void setPocetTestov(Integer pocetTestov) {
        this.pocetTestov = pocetTestov;
    }

    /**
     * @return the stavRJ
     */
    public String getStavRJ() {
        return stavRJ;
    }

    /**
     * @param stavRJ the stavRJ to set
     */
    public void setStavRJ(String stavRJ) {
        this.stavRJ = stavRJ;
    }

    /**
     * @return the simOk
     */
    public Boolean getSimOk() {
        return simOk;
    }

    /**
     * @param simOk the simOk to set
     */
    public void setSimOk(Boolean simOk) {
        this.simOk = simOk;
    }

    /**
     * @return the service
     */
    public Boolean getService() {
        return service;
    }

    /**
     * @param service the service to set
     */
    public void setService(Boolean service) {
        this.service = service;
    }
}
