package sk.tuke.fei.KpiEas.view;

import java.util.List;

/**
 * graficka reprezentacia turingovho stroja
 * @author  Stano
 */
public class TuringView extends javax.swing.JFrame {

    /** instancia aplikacie */
    private static sk.tuke.fei.KpiEas.abstraktne.Premenne main;
    /** instancia okna turingovho stroja */
    private static TuringView instance = null;
    /** model kroku pre zaznam */
    private sk.tuke.fei.KpiEas.model.Krok krok;

    /** 
     * inicializacia komponetov okna
     */
    public TuringView() {
        initComponents();
        main = sk.tuke.fei.KpiEas.abstraktne.Main.getInst().prem;
        setVisible(true);
        start();
    }

    /**
     * spustacia metoda
     * @param args argument na spustenie
     */
    public static void main(String args[]) {
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        radio = new javax.swing.ButtonGroup();
        paskaText = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        programText = new javax.swing.JTextArea();
        instruk = new javax.swing.JTextField();
        instrukLabel = new javax.swing.JLabel();
        progamLabel = new javax.swing.JLabel();
        ulozProgram = new javax.swing.JButton();
        nacitajProgram = new javax.swing.JButton();
        paskaLabel = new javax.swing.JLabel();
        statusBar = new javax.swing.JLabel();
        ulozPasku = new javax.swing.JButton();
        nacitajPasku = new javax.swing.JButton();
        pociatocneQ = new javax.swing.JTextField();
        pociatocneQLabel = new javax.swing.JLabel();
        konecneQLabel = new javax.swing.JLabel();
        konecneQ = new javax.swing.JTextField();
        indexLabel = new javax.swing.JLabel();
        index = new javax.swing.JTextField();
        simulacia = new javax.swing.JButton();
        kontrola = new javax.swing.JButton();
        prerusenie = new javax.swing.JButton();
        modePasok = new javax.swing.JCheckBox();
        stav = new javax.swing.JTextField();
        stavLabel = new javax.swing.JLabel();
        z4 = new javax.swing.JButton();
        z2 = new javax.swing.JButton();
        z3 = new javax.swing.JButton();
        z1 = new javax.swing.JButton();
        zaznamLabel = new javax.swing.JLabel();
        krokInt = new javax.swing.JTextField();
        engRadio = new javax.swing.JRadioButton();
        skRadio = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lava = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        stred = new javax.swing.JTextArea();
        zmazProgram = new javax.swing.JButton();
        zmazPaska = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        prava = new javax.swing.JTextArea();
        edukLine = new javax.swing.JLabel();
        nahodneBox = new javax.swing.JCheckBox();
        zrusOkno = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        paskaText.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                paskaTextMouseClicked(evt);
            }
        });
        paskaText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                paskaTextKeyPressed(evt);
            }
        });

        programText.setColumns(20);
        programText.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        programText.setRows(5);
        programText.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                programTextMouseClicked(evt);
            }
        });
        programText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                programTextKeyPressed(evt);
            }
        });
        jScrollPane2.setViewportView(programText);

        instruk.setEditable(false);
        instruk.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        instrukLabel.setText("Instrukcia :");

        progamLabel.setText("Program :");

        ulozProgram.setText("Uloz");
        ulozProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ulozProgramActionPerformed(evt);
            }
        });

        nacitajProgram.setText("Nacitaj");
        nacitajProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nacitajProgramActionPerformed(evt);
            }
        });

        paskaLabel.setText("Paska :");

        ulozPasku.setText("Uloz");
        ulozPasku.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ulozPaskuActionPerformed(evt);
            }
        });

        nacitajPasku.setText("Nacitaj");
        nacitajPasku.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nacitajPaskuActionPerformed(evt);
            }
        });

        pociatocneQ.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                pociatocneQMouseClicked(evt);
            }
        });
        pociatocneQ.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                pociatocneQKeyPressed(evt);
            }
        });

        pociatocneQLabel.setText("Pociatocne Q :");

        konecneQLabel.setText("Konecne Q :");

        konecneQ.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                konecneQMouseClicked(evt);
            }
        });
        konecneQ.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                konecneQKeyPressed(evt);
            }
        });

        indexLabel.setText("Index pasky :");

        index.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                indexMouseClicked(evt);
            }
        });
        index.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                indexKeyPressed(evt);
            }
        });

        simulacia.setText("Simulacia");
        simulacia.setEnabled(false);
        simulacia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                simulaciaActionPerformed(evt);
            }
        });

        kontrola.setText("Kontrola");
        kontrola.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kontrolaActionPerformed(evt);
            }
        });

        prerusenie.setText("Prerusenie");
        prerusenie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prerusenieActionPerformed(evt);
            }
        });

        modePasok.setText("Viac pasok");
        modePasok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                modePasokActionPerformed(evt);
            }
        });

        stav.setEditable(false);
        stav.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        stavLabel.setText("Stav :");

        z4.setText(">>");
        z4.setEnabled(false);
        z4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                z4ActionPerformed(evt);
            }
        });

        z2.setText("<");
        z2.setEnabled(false);
        z2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                z2ActionPerformed(evt);
            }
        });

        z3.setText(">");
        z3.setEnabled(false);
        z3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                z3ActionPerformed(evt);
            }
        });

        z1.setText("<<");
        z1.setEnabled(false);
        z1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                z1ActionPerformed(evt);
            }
        });

        zaznamLabel.setText("Zaznam :");

        krokInt.setEditable(false);
        krokInt.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        radio.add(engRadio);
        engRadio.setText("ENG");
        engRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                engRadioActionPerformed(evt);
            }
        });

        radio.add(skRadio);
        skRadio.setText("SK");
        skRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                skRadioActionPerformed(evt);
            }
        });

        lava.setColumns(15);
        lava.setEditable(false);
        lava.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        lava.setRows(5);
        lava.setMinimumSize(new java.awt.Dimension(5, 18));
        jScrollPane1.setViewportView(lava);

        stred.setColumns(6);
        stred.setEditable(false);
        stred.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        stred.setRows(5);
        jScrollPane4.setViewportView(stred);

        zmazProgram.setText("Zmaz");
        zmazProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zmazProgramActionPerformed(evt);
            }
        });

        zmazPaska.setText("Zmaz");
        zmazPaska.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zmazPaskaActionPerformed(evt);
            }
        });

        prava.setColumns(15);
        prava.setEditable(false);
        prava.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        prava.setRows(5);
        prava.setMinimumSize(new java.awt.Dimension(5, 18));
        jScrollPane3.setViewportView(prava);

        nahodneBox.setText("Nahodne");
        nahodneBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nahodneBoxActionPerformed(evt);
            }
        });

        zrusOkno.setText("Zrusit");
        zrusOkno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zrusOknoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addComponent(zaznamLabel)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(z1)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(z2)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(krokInt, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(z3)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(z4))
                                .addComponent(jScrollPane4))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jScrollPane3)
                                .addComponent(nahodneBox)))
                        .addComponent(progamLabel, javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addComponent(modePasok)
                                    .addGap(18, 18, 18)
                                    .addComponent(stavLabel)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(stav))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addComponent(instrukLabel)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(instruk, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGap(18, 18, 18)
                            .addComponent(prerusenie)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(simulacia)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(kontrola))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(ulozProgram)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(nacitajProgram)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(zmazProgram))
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 266, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(ulozPasku)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(nacitajPasku)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(zmazPaska))
                                    .addComponent(paskaLabel)
                                    .addComponent(paskaText, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 253, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(skRadio)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(engRadio)))
                                .addGroup(layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(indexLabel)
                                        .addComponent(konecneQLabel)
                                        .addComponent(pociatocneQLabel))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(konecneQ, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(index, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(pociatocneQ, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(zrusOkno))))))
                    .addComponent(edukLine, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 546, Short.MAX_VALUE)
                    .addComponent(statusBar, javax.swing.GroupLayout.DEFAULT_SIZE, 546, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(13, 13, 13)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(stavLabel)
                            .addComponent(stav, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(modePasok))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(instrukLabel)
                            .addComponent(instruk, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(simulacia)
                            .addComponent(kontrola)
                            .addComponent(prerusenie)))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(engRadio)
                            .addComponent(skRadio))))
                .addGap(9, 9, 9)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(zaznamLabel)
                            .addComponent(z1, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(z2, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(krokInt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(z3, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(z4, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(progamLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nahodneBox)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(paskaLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(paskaText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(ulozPasku)
                            .addComponent(nacitajPasku)
                            .addComponent(zmazPaska))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 49, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(pociatocneQ, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(pociatocneQLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(konecneQ, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(konecneQLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(index, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(indexLabel)))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(zmazProgram)
                    .addComponent(nacitajProgram)
                    .addComponent(ulozProgram)
                    .addComponent(zrusOkno))
                .addGap(24, 24, 24)
                .addComponent(statusBar, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edukLine, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void programTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_programTextKeyPressed
    simulacia.setEnabled(false);
}//GEN-LAST:event_programTextKeyPressed

private void paskaTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_paskaTextKeyPressed
    simulacia.setEnabled(false);
}//GEN-LAST:event_paskaTextKeyPressed

private void pociatocneQKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_pociatocneQKeyPressed
    simulacia.setEnabled(false);
}//GEN-LAST:event_pociatocneQKeyPressed

private void konecneQKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_konecneQKeyPressed
    simulacia.setEnabled(false);
}//GEN-LAST:event_konecneQKeyPressed

private void indexKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_indexKeyPressed
    simulacia.setEnabled(false);
}//GEN-LAST:event_indexKeyPressed

private void skRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_skRadioActionPerformed
    main.lang.setLang(1, 1);
    setLang();
}//GEN-LAST:event_skRadioActionPerformed

private void engRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_engRadioActionPerformed
    main.lang.setLang(1, 2);
    setLang();
}//GEN-LAST:event_engRadioActionPerformed

private void zmazProgramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zmazProgramActionPerformed
    programText.setText("");
    simulacia.setEnabled(false);
}//GEN-LAST:event_zmazProgramActionPerformed

private void ulozProgramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ulozProgramActionPerformed
    setEnabled(false);
    main.cache.setProgram(programText.getText());
    main.cache.setPocStav(pociatocneQ.getText());
    main.cache.setKonStav(konecneQ.getText());
    main.cache.setPozPas(index.getText().trim());
    main = main.subor.saveProgram(main);
    setEnabled(true);
    setAlwaysOnTop(true);
    setAlwaysOnTop(false);
    statusBar.setText(main.cache.getErrLine());
}//GEN-LAST:event_ulozProgramActionPerformed

private void nacitajProgramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nacitajProgramActionPerformed
    setEnabled(false);
    main = main.subor.readProgram(main);
    programText.setText(main.cache.getProgram());
    pociatocneQ.setText(main.cache.getPocStav());
    konecneQ.setText(main.cache.getKonStav());
    setEnabled(true);
    setAlwaysOnTop(true);
    setAlwaysOnTop(false);
    statusBar.setText(main.cache.getErrLine());
    simulacia.setEnabled(false);
}//GEN-LAST:event_nacitajProgramActionPerformed

private void ulozPaskuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ulozPaskuActionPerformed
    setEnabled(false);
    main.cache.setPaska(paskaText.getText());
    main = main.subor.savePaska(main, true);
    setEnabled(true);
    setAlwaysOnTop(true);
    setAlwaysOnTop(false);
    statusBar.setText(main.cache.getErrLine());
}//GEN-LAST:event_ulozPaskuActionPerformed

private void nacitajPaskuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nacitajPaskuActionPerformed
    setEnabled(false);
    main = main.subor.readPaska(main, true);
    paskaText.setText(main.cache.getPaska());
    setEnabled(true);
    setAlwaysOnTop(true);
    setAlwaysOnTop(false);
    statusBar.setText(main.cache.getErrLine());
    simulacia.setEnabled(false);
}//GEN-LAST:event_nacitajPaskuActionPerformed

private void zmazPaskaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zmazPaskaActionPerformed
    paskaText.setText("");
    simulacia.setEnabled(false);
}//GEN-LAST:event_zmazPaskaActionPerformed

private void z1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_z1ActionPerformed
    main.zaznam.setKrokI(0);
    z1.setEnabled(false);
    z2.setEnabled(false);
    z3.setEnabled(true);
    z4.setEnabled(true);
    writeKrok(main.zaznam.getKrokI());
    statusBar.setText("");
    main.cache.setErrLine("");
}//GEN-LAST:event_z1ActionPerformed

private void z2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_z2ActionPerformed
    int a = main.zaznam.getKrokI() - 1;
    main.zaznam.setKrokI(a);
    if (main.zaznam.getKrokI() == 0) {
        z1.setEnabled(false);
        z2.setEnabled(false);
    }
    z3.setEnabled(true);
    z4.setEnabled(true);
    writeKrok(main.zaznam.getKrokI());
    statusBar.setText("");
    main.cache.setErrLine("");
}//GEN-LAST:event_z2ActionPerformed

private void z3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_z3ActionPerformed
    int a = main.zaznam.getKrokI() + 1;
    main.zaznam.setKrokI(a);
    if (main.zaznam.getKrokI() == (main.zaznam.size() - 1)) {
        z3.setEnabled(false);
        z4.setEnabled(false);
    }
    z1.setEnabled(true);
    z2.setEnabled(true);
    writeKrok(main.zaznam.getKrokI());
}//GEN-LAST:event_z3ActionPerformed

private void z4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_z4ActionPerformed
    main.zaznam.setKrokI(main.zaznam.size() - 1);
    z1.setEnabled(true);
    z2.setEnabled(true);
    z3.setEnabled(false);
    z4.setEnabled(false);
    writeKrok(main.zaznam.getKrokI());
}//GEN-LAST:event_z4ActionPerformed

private void modePasokActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_modePasokActionPerformed
    if (modePasok.isSelected()) {
        main.program.setViacPas(true);
    } else {
        main.program.setViacPas(false);
    }
    simulacia.setEnabled(false);
}//GEN-LAST:event_modePasokActionPerformed

private void prerusenieActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prerusenieActionPerformed
    main.program.setPrerus(true);
}//GEN-LAST:event_prerusenieActionPerformed

private void simulaciaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_simulaciaActionPerformed
    Thread thread = new sk.tuke.fei.KpiEas.abstraktne.Vlakno();
    thread.start();
}//GEN-LAST:event_simulaciaActionPerformed

private void kontrolaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kontrolaActionPerformed
    main.cache.clrErrLine();
    kontrola();
    statusBar.setText(main.cache.getErrLine());
}//GEN-LAST:event_kontrolaActionPerformed
private void programTextMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_programTextMouseClicked
    simulacia.setEnabled(false);
}//GEN-LAST:event_programTextMouseClicked
private void paskaTextMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_paskaTextMouseClicked
    simulacia.setEnabled(false);
}//GEN-LAST:event_paskaTextMouseClicked
private void pociatocneQMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_pociatocneQMouseClicked
    simulacia.setEnabled(false);
}//GEN-LAST:event_pociatocneQMouseClicked
private void konecneQMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_konecneQMouseClicked
    simulacia.setEnabled(false);
}//GEN-LAST:event_konecneQMouseClicked
private void indexMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_indexMouseClicked
    simulacia.setEnabled(false);
}//GEN-LAST:event_indexMouseClicked
private void nahodneBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nahodneBoxActionPerformed
    if (nahodneBox.isSelected()) {
        main.program.setNahodne(true);
    } else {
        main.program.setNahodne(false);
    }
}//GEN-LAST:event_nahodneBoxActionPerformed

private void zrusOknoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zrusOknoActionPerformed
    this.hide();
    UvodView v = new UvodView();
    v.show();
    this.dispose();
}//GEN-LAST:event_zrusOknoActionPerformed

    /**
     * vypis pri spracovani simulacie
     * @param a zaznam komponentov na vypis
     */
    public void setPasky(List<String> a) {
        lava.setText(a.get(0).toString());
        stred.setText(a.get(1).toString());
        prava.setText(a.get(2).toString());
        stav.setText(a.get(3).toString());
        setKrok();


    }

    /**
     * nastavenie vypisu instrukcie pocas simulacie
     * @param i cislo instrukcie
     */
    public void setRunInst(int i) {
        instruk.setText(main.program.getProgram().get(i).getLine());
        setKrok();


    }

    /**
     * nastavenie edukacnej zlozky
     * @param s vypis
     */
    public void setEduk(String s) {
        edukLine.setText(s);
    }

    /**
     * nastavenie statusbaru
     */
    public void setErr() {
        statusBar.setText(main.cache.getErrLine());
    }

    /**
     * ulozenie kroku do zaznamu
     */
    private void setKrok() {
        krok = new sk.tuke.fei.KpiEas.model.Krok();
        krok.setInst(instruk.getText());
        krok.setStav(stav.getText());
        krok.setPaska(0, lava.getText());
        krok.setPaska(1, stred.getText());
        krok.setPaska(2, prava.getText());
        krok.setEduk(edukLine.getText());
        main.zaznam.vlozZaznam(krok);
        krokInt.setText(String.valueOf(main.zaznam.size() - 1));
    }

    /**
     * vypis kroku do pola simulacie
     * @param i poradie kroku
     */
    private void writeKrok(int i) {
        if (i < 0) {
            i = 0;
        }
        if (i >= main.zaznam.size()) {
            i = main.zaznam.size() - 1;
        }
        krok = main.zaznam.nacitajZaznam(i);
        stav.setText(krok.getStav());
        instruk.setText(krok.getInst());
        lava.setText(krok.getPaska(0));
        stred.setText(krok.getPaska(1));
        prava.setText(krok.getPaska(2));
        krokInt.setText(Integer.toString(i));
        edukLine.setText(krok.getEduk());
    }

    /**
     * vycistanie pola simulacie
     */
    public void cleanOkno() {
        instruk.setText("");
        lava.setText("");
        stred.setText("");
        prava.setText("");
        stav.setText("");
        statusBar.setText("");
        edukLine.setText("");
        main.cache.setErrLine("");
        main.cache.setEdukLine("");
    }

    /**
     * nastavenie pristupu k tlacidlam a panelom
     * @param pri povolenie alebo nepovolenie
     */
    public void pristupOkno(Boolean pri) {

        paskaText.setEditable(pri);
        pociatocneQ.setEditable(pri);
        konecneQ.setEditable(pri);
        index.setEditable(pri);
        programText.setEditable(pri);
        modePasok.setEnabled(pri);
        zrusOkno.setEnabled(pri);

        z1.setEnabled(pri);
        z2.setEnabled(pri);
        z3.setEnabled(pri);
        z4.setEnabled(pri);
        skRadio.setEnabled(pri);
        engRadio.setEnabled(pri);
        kontrola.setEnabled(pri);
        nacitajPasku.setEnabled(pri);
        nacitajProgram.setEnabled(pri);
        ulozPasku.setEnabled(pri);
        ulozProgram.setEnabled(pri);
        nahodneBox.setEnabled(pri);
    }

    /**
     * nastavenie jazyka v okne simulacie
     */
    private void setLang() {
        setTitle(main.lang.getOther(0));
        zrusOkno.setText(main.lang.getText(29));

        instrukLabel.setText(main.lang.getOther(1));
        progamLabel.setText(main.lang.getOther(2));
        paskaLabel.setText(main.lang.getOther(3));
        pociatocneQLabel.setText(main.lang.getOther(4));
        konecneQLabel.setText(main.lang.getOther(5));
        indexLabel.setText(main.lang.getOther(15));
        stavLabel.setText(main.lang.getOther(6));
        zaznamLabel.setText(main.lang.getOther(7));

        modePasok.setText(main.lang.getOther(16));
        ulozProgram.setText(main.lang.getOther(9));
        nacitajProgram.setText(main.lang.getOther(10));
        ulozPasku.setText(main.lang.getOther(9));
        nacitajPasku.setText(main.lang.getOther(10));
        prerusenie.setText(main.lang.getOther(12));
        simulacia.setText(main.lang.getOther(13));
        kontrola.setText(main.lang.getOther(14));
        zmazPaska.setText(main.lang.getOther(11));
        zmazProgram.setText(main.lang.getOther(11));
        nahodneBox.setText(main.lang.getOther(8));
    }

    /**
     * nastavenie pociatocnej formy vypisu
     */
    public void zacnas() {
        simulacia.setEnabled(false);
        pristupOkno(true);
        main.zaznam.setKrokI(main.zaznam.size() - 1);
        writeKrok(main.zaznam.getKrokI());
        z3.setEnabled(false);
        z4.setEnabled(false);

        if (main.zaznam.size() == 1) {
            z1.setEnabled(false);
            z2.setEnabled(false);
        }
    }

    /**
     * kontrola vstupneho programu a pasky s povoleniem spustenia
     */
    private void kontrola() {
        main.paska.getPaska().clear();
        main.program.getProgram().clear();
        main.cache.setErrLine(null);
        main.program.setPasInt(0);

        main.program.setPrerus(false);
        main.program.setVyberbool(false);
        main.paska.getPozPasky().clear();

        cleanOkno();
        simulacia.setEnabled(false);
        Boolean start = false;

        if (programText.getText().isEmpty()) {
            statusBar.setText(main.lang.getText(0));
            main.cache.setErrLine(main.lang.getText(0));
        } else if (paskaText.getText().isEmpty()) {
            statusBar.setText(main.lang.getText(1));
            main.cache.setErrLine(main.lang.getText(1));
        } else if (pociatocneQ.getText().isEmpty() || konecneQ.getText().isEmpty()) {
            statusBar.setText(main.lang.getText(2));
            main.cache.setErrLine(main.lang.getText(2));
        } else {
            main.program.setZacStav(pociatocneQ.getText().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(konecneQ.getText().toString().trim(), ","));
            main.cache.setProgram(programText.getText());
            main.cache.setPaska(paskaText.getText());
            main.cache.setErrLine(statusBar.getText());
            main.cache.setPozPas(index.getText().trim());

            if (main.cache.getErrLine().contentEquals("")) {
                main = main.subor.kontrolaProgramu(main);
                start = main.kontrola;
                if (start) {
                    simulacia.setEnabled(true);
                }
            }
        }
    }

    /**
     * nastavenie startovacej ppozicie okna
     */
    private void start() {
        main.lang.setLang(1, 1);
        setLang();
        skRadio.setSelected(true);
        nahodneBox.setSelected(false);
        modePasok.setSelected(false);
        main.program.setViacPas(false);
        main.program.setNahodne(false);


    }

    /**
     * ziskanie instancie okna turingovho stoja
     * @return instancia okna turingovho stoja
     */
    public static TuringView getInst() {
        if (instance == null) {
            instance = new TuringView();
        }
        return instance;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel edukLine;
    private javax.swing.JRadioButton engRadio;
    private javax.swing.JTextField index;
    private javax.swing.JLabel indexLabel;
    private javax.swing.JTextField instruk;
    private javax.swing.JLabel instrukLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTextField konecneQ;
    private javax.swing.JLabel konecneQLabel;
    private javax.swing.JButton kontrola;
    private javax.swing.JTextField krokInt;
    private javax.swing.JTextArea lava;
    private javax.swing.JCheckBox modePasok;
    private javax.swing.JButton nacitajPasku;
    private javax.swing.JButton nacitajProgram;
    private javax.swing.JCheckBox nahodneBox;
    private javax.swing.JLabel paskaLabel;
    private javax.swing.JTextField paskaText;
    private javax.swing.JTextField pociatocneQ;
    private javax.swing.JLabel pociatocneQLabel;
    private javax.swing.JTextArea prava;
    private javax.swing.JButton prerusenie;
    private javax.swing.JLabel progamLabel;
    private javax.swing.JTextArea programText;
    private javax.swing.ButtonGroup radio;
    private javax.swing.JButton simulacia;
    private javax.swing.JRadioButton skRadio;
    private javax.swing.JLabel statusBar;
    private javax.swing.JTextField stav;
    private javax.swing.JLabel stavLabel;
    private javax.swing.JTextArea stred;
    private javax.swing.JButton ulozPasku;
    private javax.swing.JButton ulozProgram;
    private javax.swing.JButton z1;
    private javax.swing.JButton z2;
    private javax.swing.JButton z3;
    private javax.swing.JButton z4;
    private javax.swing.JLabel zaznamLabel;
    private javax.swing.JButton zmazPaska;
    private javax.swing.JButton zmazProgram;
    private javax.swing.JButton zrusOkno;
    // End of variables declaration//GEN-END:variables
}
