/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * VyberDialog.java
 *
 * Created on 6.1.2011, 22:44:09
 */
package sk.tuke.fei.KpiEas.view;


import javax.swing.DefaultListModel;

/**
 * dialog pre vyber instrukcie v pripade duplicity
 * @author Stano
 */
public class VyberDialog extends javax.swing.JDialog {

    /** instancia aplikacie */
    private static sk.tuke.fei.KpiEas.abstraktne.Premenne main;

    /**
     * inicializacia dialogoveho okna
     * @param parent
     * @param modal
     */
    public VyberDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        main = sk.tuke.fei.KpiEas.abstraktne.Main.getInst().prem;
        setTitle(main.lang.getText(42));
        if (main.program.getTyp() == 1) {
            setLocationRelativeTo(main.turingView);
            ok.setText(main.lang.getText(30));
            zrus.setText(main.lang.getText(29));
            label.setText(main.lang.getText(40));
        }
        if (main.program.getTyp() == 2) {
            setLocationRelativeTo(main.zasobView);
            ok.setText(main.lang.getText(26));
            zrus.setText(main.lang.getText(29));
            label.setText(main.lang.getText(30));
        }
        if (main.program.getTyp() == 3) {
            setLocationRelativeTo(main.konView);
            ok.setText(main.lang.getText(26));
            zrus.setText(main.lang.getText(24));
            label.setText(main.lang.getText(14));
        }
        naplnVyber(main.program.getVyberstr());
    }

    /**
     * nastavenie moznosti vyberu
     * @param vyber zoznam moznosti vyberu
     */
    private void naplnVyber(String vyber) {
        String[] split = null;
        DefaultListModel model = new DefaultListModel();
        split = vyber.split("\n");
        text.removeAllItems();
        for (int i = 0; i < split.length; i++) {
            model.addElement(split[i].toString());
            text.addItem(split[i].toString());
        }
    }

    /**
     * zistenie vybranej hodnoty instrukcie
     */
    private void rozhod() {
        String str = text.getItemAt(text.getSelectedIndex()).toString();
        String[] split = str.split(",");
        int i = Integer.parseInt(split[0]);
        main.program.setVyberbool(false);
        main.program.setVyberI(i);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        label = new javax.swing.JLabel();
        text = new javax.swing.JComboBox();
        ok = new javax.swing.JButton();
        zrus = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setLocationByPlatform(true);

        label.setText("Vyberte pozadovanu instrukciu :");
        label.setName("label"); // NOI18N

        text.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        text.setName("text"); // NOI18N

        ok.setText("OK");
        ok.setName("ok"); // NOI18N
        ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okActionPerformed(evt);
            }
        });

        zrus.setText("Zrušit");
        zrus.setName("zrus"); // NOI18N
        zrus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zrusActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(text, javax.swing.GroupLayout.Alignment.LEADING, 0, 155, Short.MAX_VALUE)
                            .addComponent(label, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(44, 44, 44))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(ok)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(zrus)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(label)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(text, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 84, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(zrus)
                    .addComponent(ok))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okActionPerformed
        rozhod();
        sk.tuke.fei.KpiEas.abstraktne.Main.getInst().prem = main;
        dispose();
}//GEN-LAST:event_okActionPerformed

    private void zrusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zrusActionPerformed
        main.program.setPrerus(true);
        main.program.setVyberbool(false);
        sk.tuke.fei.KpiEas.abstraktne.Main.getInst().prem = main;
        dispose();
}//GEN-LAST:event_zrusActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                VyberDialog dialog = new VyberDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel label;
    private javax.swing.JButton ok;
    private javax.swing.JComboBox text;
    private javax.swing.JButton zrus;
    // End of variables declaration//GEN-END:variables
}
