﻿/**
 * Check code with external parser
 *
 * @param nameprefix Prefixname of inputs/textareas
 * @param count Total count of inputs/textareas
 *
 * @return string  
 */

function checkCode(nameprefix,count){
    var code = get_responses (nameprefix, count); //get all responses from student
    var http = getHTTPObject();   
  
    var wwwroot = document.getElementById('www_root').value;  
    var dirroot = document.getElementById('dir_root').value;
    var newcode = code.replace(/\r\n|\r|\n/g,"\n"); //replace textarea new lines symbols
    var newcode = newcode.replace(/&/g, "{@@@}");
  //  alert (newcode);
    
    var ico_url = wwwroot + "/question/type/abstraktne/pics/loading.gif"; 
    document.getElementById(nameprefix + "checker_c").innerHTML = '<img src=' + ico_url + '>';   
    var params = 'code=' + newcode + "&data=" + document.getElementById(nameprefix + 'machine_config').value + "&dirroot=" + dirroot;
    
    var url = wwwroot + "/question/type/abstraktne/scripts/check_error.php";
    http.open("POST", url, true);
    http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    http.setRequestHeader("Content-length", params.length);
    http.setRequestHeader("Connection", "close");    
    http.onreadystatechange = function() {
        if (http.readyState == 4) {
            if (http.status == 200 || http.status == 304) {
                var wsresponse = http.responseText;
                if(wsresponse == '0') {
                    url = wwwroot + "/question/type/abstraktne/pics/cross_red_big.gif"; 
                    document.getElementById(nameprefix + "checker_c").innerHTML = '<img src=' + url + '>';
                 
                } else if(wsresponse == '100'){
                    url = wwwroot + "/question/type/abstraktne/pics/tick_green_big.gif"; 
                    document.getElementById(nameprefix + "checker_c").innerHTML = '<img src=' + url + '>';     
                } else { 
                    document.getElementById(nameprefix + "checker_c").innerHTML = 'Communication error. Try again.';
                } 
            }  
        } 
    }               
    http.send(params);  
}

/**
 * Creates a XMLHTTP object
 * 
 * @return object  
 */
function getHTTPObject(){
    if (window.ActiveXObject) // code for IE6, IE5
        return new ActiveXObject("Microsoft.XMLHTTP");
    else if (window.XMLHttpRequest) // code for IE7+, Firefox, Chrome, Opera, Safari
        return new XMLHttpRequest();
    else {
        alert("Your browser does not support AJAX.");
        return null;
    }
}

/**
 * Load all studnets answers from input boxes
 *
 * @param prefix Prefixname of inputs/textareas
 * @param count Total count of inputs/textareas
 *
 * @return string  
 */

function get_responses (prefix, count)
{
    var responses = ""
    var separator = "\n";
    for (i=0;i<count;i++)
    {
        if (i+1 == count)
        {
            separator = "";
        }
        responses += document.getElementById(prefix + i).value + separator;
    }
    return responses;
}